%global forgeurl        https://github.com/dreamworksanimation
%global cmodver         1.0.0.5

%bcond tests    1

Name:           arras4_core
Version:        4.10.3.10
Release:        %{autorelease}
Summary:        Core Arras libraries

License:        Apache-2.0
URL:            https://openmoonray.org/
Source0:        %{forgeurl}/%{name}/archive/refs/tags/%{name}-%{version}.tar.gz
Source1:        %{forgeurl}/cmake_modules/archive/refs/tags/cmake_modules-%{cmodver}.tar.gz

Patch0:         %{name}-sysloglogger.patch
Patch1:         %{name}-env.patch

BuildRequires:  gcc-c++
BuildRequires:  cmake >= 3.23.1
BuildRequires:  libatomic
BuildRequires:  libuuid-devel
BuildRequires:  libmicrohttpd-devel
BuildRequires:  jsoncpp-devel
BuildRequires:  boost-devel

BuildRequires:  pkgconfig(cppunit)
BuildRequires:  pkgconfig(libcurl)
BuildRequires:  pkgconfig(openssl)


Provides:       ArrasCore = %{version}

%description
Arras is a framework for interactive distributed computation.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

Requires:       boost-devel
Requires:       libuuid-devel
Requires:       libmicrohttpd-devel
Requires:       pkgconfig(libcurl)
Requires:       libatomic
Requires:       pkgconfig(openssl)
Requires:       jsoncpp-devel

%description    devel
The %{name}-devel package contains libraries and header files of %{name}, required to build other parts of OpenMoonRay.


%prep
%autosetup -p1 -n %{name}-%{name}-%{version}
mkdir -p cmake_modules
tar -xzf %{SOURCE1} --strip-components=1 -C $_

# Change inexistent python path on Fedora
sed -i '1s|.*|#!/usr/bin/python3|' \
        arras4_log/mod/python/breakpad/breakpadProcess

# Restructure
sed -i 's|sessions|${CMAKE_INSTALL_LIBDIR}/openmoonray/sessions|g' \
        arras4_test/sessions/nonrez/CMakeLists.txt


%build
ARRAS_SESSION_PATH=%{_libdir}/openmoonray/sessions \
%cmake \
    -DCMAKE_MODULE_PATH=%{builddir}/%{buildsubdir}/cmake_modules/cmake \
    -DBUILD_TESTING=%{expr:%{with tests}?"ON":"OFF"} \
    -DCMAKE_EXE_LINKER_FLAGS:STRING='-Wl,-O1,--sort-common,-z,relro,-z,now'
%cmake_build


%install
%cmake_install


%files
%license LICENSE
%{_bindir}/{arras4test,execComp,msgInfo,msgPlay,runComp}
%{_libdir}/libarras4_{athena,log}.so
%{_libdir}/lib{chunking,core_messages,execute,http,httpserver,log_client,network,routing,sdk,shared_impl,standalone}.so
%{_libdir}/libtest{computation,message}.so
%{_libdir}/libclient_{api,local}.so
%{_libdir}/libcomputation_{api,impl}.so
%{_libdir}/libmessage_{api,impl}.so
%{_libdir}/openmoonray/sessions/multi_reply_test.sessiondef
%{_libdir}/openmoonray/sessions/reply_test.sessiondef
%{_libdir}/openmoonray/sessions/simple_test.sessiondef

%files devel
%{_includedir}/arras4_{athena,log}
%{_includedir}/{chunking,client,core_messages,exceptions,execute,http,httpserver,log_client,network,routing,sdk,shared_impl,standalone}
%{_includedir}/test{computation,message}
%{_includedir}/computation_{api,impl}
%{_includedir}/message_{api,impl}
%{_libdir}/cmake/ArrasCore-%(echo %{version} | sed 's/\(.*\)\.[0-9]*$/\1/').0

%changelog
%autochangelog
